[a]: https://code.mensbeam.com/MensBeam/Policy/src/master/CODE-OF-CONDUCT.md
[b]: https://code.mensbeam.com/MensBeam/arsse/issues
[c]: http://www.php-fig.org/psr/psr-2/

# Contributing to The Arsse

We would love for you to contribute to our little project and to make The Arsse better. Here are the guidelines we would like you to follow:

* [Code of Conduct](#code-of-conduct)
* [Questions, Bugs, & Feature Requests](#questions-bugs-features)
* [Submission Guidelines](#submission-guidelines)
* [Coding Rules](#coding-rules)

## <a name="code-of-conduct"></a> Code of Conduct

We strive to keep The Arsse open and inclusive. Please read our [Code of Conduct][a] and follow its guidelines when interacting with others within this community.

## <a name="questions-issues-bugs-features"></a> Questions, Bugs & Feature Requests

Questions about how to use The Arsse, bugs, or feature requests can be directed at the [issues page][b].

## <a name="submission-guidelines"></a> Submission Guidelines

### Submitting an issue

Before you submit your issue search the archive to see if your question has been answered for you already. If your issue is new and hasn't been reported open a new issue; please do not report duplicate issues. We would like for you to provide the following information with each issue as it helps us help you:

1. *Overview* – Always submit stack traces if the bug produces one.
2. *Versions* – What version of The Arsse, php, and operating system are you using?
3. *Reproduce* - Provide a set of steps to reproduce the issue.
4. *Related* - Provide any issues you think might be related.
5. *Suggestions* - If you cannot fix the bug yourself provide any suggestions for fixing the issue.

### Submitting a Pull Request

Before you submit your pull request search for an existing open or closed pull request. Please refrain from duplicating pull requests.

## <a name="coding-rules"></a> Coding Rules

We would like to ensure consistency in our source code, so we follow the [PSR-2 guidelines][c] with one notable exception (utilizing the notation used and outlined in the original document):

**Opening braces for classes and methods MUST go on the same line, and closing braces MUST go on the next line after the body.**
